using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace ObserverPattern_Parkeringshus
{
    public partial class FormObserver : Form
    {
        private P_Hus_Monitor phus;
        public FormObserver(P_Hus_Monitor phus)
        {
            InitializeComponent();
            this.phus = phus;
        }

        private void FormObserver_FormClosed(object sender, FormClosedEventArgs e)
        {
            phus.P_Hus_EventAlle -= externThread_BeskedModtager;       // afmeld observer
            phus.P_Hus_EventInd -= externThread_BeskedModtager;       // afmeld observer
            phus.P_Hus_EventIndStart -= externThread_BeskedModtager;       // afmeld observer
            phus.P_Hus_EventIndSlut -= externThread_BeskedModtager;       // afmeld observer
            phus.P_Hus_EventIndVenter -= externThread_BeskedModtager;       // afmeld observer
            phus.P_Hus_EventFyldt -= externThread_BeskedModtager;       // afmeld observer
            phus.P_Hus_EventIkkeTomt -= externThread_BeskedModtager;       // afmeld observer
            phus.P_Hus_EventUd -= externThread_BeskedModtager;       // afmeld observer
            phus.P_Hus_EventUdStart -= externThread_BeskedModtager;       // afmeld observer
            phus.P_Hus_EventUdSlut -= externThread_BeskedModtager;       // afmeld observer
            phus.P_Hus_EventUdVenter -= externThread_BeskedModtager;       // afmeld observer
            phus.P_Hus_EventTmt -= externThread_BeskedModtager;       // afmeld observer
            phus.P_Hus_EventIkkeFyldt -= externThread_BeskedModtager;       // afmeld observer
        }


        private void btnClear_Click(object sender, EventArgs e)
        {
            tbxLog.Clear();
        }

        private void externThread_BeskedModtager(string besked, P_Hus_Monitor p_hus)
        {
            try
            {
                // GUI komponentern kan ikke tilgs direkte fra en anden trd end GUI-trden
                // Det er ndvendigt at bruge Invoke metoden og lave en
                P_Hus_Monitor.EventHandler phusEvent_form = formThread_BeskedModtager;
                this.Invoke(phusEvent_form, besked, p_hus);  // her anvendes et delegat som er oprettet i Form-klassen forinden
            }
            catch { }       // try-catch ndvendig, da event kan komme under lukningen af winduet
        }

        private void formThread_BeskedModtager(string besked, P_Hus_Monitor p_hus)
        {
            tbxLog.AppendText(besked + "\r\n");
        }

        private void cbxAlle_CheckedChanged(object sender, EventArgs e)
        {
            if (cbxAlle.Checked)
                phus.P_Hus_EventAlle += externThread_BeskedModtager;       // tilmeld observer
            else
                phus.P_Hus_EventAlle -= externThread_BeskedModtager;       // afmeld observer
        }

        private void cbxInd_CheckedChanged(object sender, EventArgs e)
        {
            if (cbxInd.Checked)
                phus.P_Hus_EventInd += externThread_BeskedModtager;       // tilmeld observer
            else
                phus.P_Hus_EventInd -= externThread_BeskedModtager;       // afmeld observer
        }

        private void cbxIndStart_CheckedChanged(object sender, EventArgs e)
        {
            if (cbxIndStart.Checked)
                phus.P_Hus_EventIndStart += externThread_BeskedModtager;       // tilmeld observer
            else
                phus.P_Hus_EventIndStart -= externThread_BeskedModtager;       // afmeld observer
        }

        private void cbxIndSlut_CheckedChanged(object sender, EventArgs e)
        {
            if (cbxIndSlut.Checked)
                phus.P_Hus_EventIndSlut += externThread_BeskedModtager;       // tilmeld observer
            else
                phus.P_Hus_EventIndSlut -= externThread_BeskedModtager;       // afmeld observer
        }

        private void cbxIndVenter_CheckedChanged(object sender, EventArgs e)
        {
            if (cbxIndVenter.Checked)
                phus.P_Hus_EventIndVenter += externThread_BeskedModtager;       // tilmeld observer
            else
                phus.P_Hus_EventIndVenter -= externThread_BeskedModtager;       // afmeld observer
        }

        private void cbxFyldt_CheckedChanged(object sender, EventArgs e)
        {
            if (cbxFyldt.Checked)
                phus.P_Hus_EventFyldt += externThread_BeskedModtager;       // tilmeld observer
            else
                phus.P_Hus_EventFyldt -= externThread_BeskedModtager;       // afmeld observer
        }

        private void cbxIkkeTmt_CheckedChanged(object sender, EventArgs e)
        {
            if (cbxIkkeTmt.Checked)
                phus.P_Hus_EventIkkeTomt += externThread_BeskedModtager;       // tilmeld observer
            else
                phus.P_Hus_EventIkkeTomt -= externThread_BeskedModtager;       // afmeld observer
        }

        private void cbxUd_CheckedChanged(object sender, EventArgs e)
        {
            if (cbxUd.Checked)
                phus.P_Hus_EventUd += externThread_BeskedModtager;       // tilmeld observer
            else
                phus.P_Hus_EventUd -= externThread_BeskedModtager;       // afmeld observer
        }

        private void cbxUdStart_CheckedChanged(object sender, EventArgs e)
        {
            if (cbxUdStart.Checked)
                phus.P_Hus_EventUdStart += externThread_BeskedModtager;       // tilmeld observer
            else
                phus.P_Hus_EventUdStart -= externThread_BeskedModtager;       // afmeld observer
        }

        private void cbxUdSlut_CheckedChanged(object sender, EventArgs e)
        {
            if (cbxUdSlut.Checked)
                phus.P_Hus_EventUdSlut += externThread_BeskedModtager;       // tilmeld observer
            else
                phus.P_Hus_EventUdSlut -= externThread_BeskedModtager;       // afmeld observer
        }

        private void cbxUdVenter_CheckedChanged(object sender, EventArgs e)
        {
            if (cbxUdVenter.Checked)
                phus.P_Hus_EventUdVenter += externThread_BeskedModtager;       // tilmeld observer
            else
                phus.P_Hus_EventUdVenter -= externThread_BeskedModtager;       // afmeld observer
        }

        private void cbxTmt_CheckedChanged(object sender, EventArgs e)
        {
            if (cbxTmt.Checked)
                phus.P_Hus_EventTmt += externThread_BeskedModtager;       // tilmeld observer
            else
                phus.P_Hus_EventTmt -= externThread_BeskedModtager;       // afmeld observer
        }

        private void cbxIkkeFyldt_CheckedChanged(object sender, EventArgs e)
        {
            if (cbxIkkeFyldt.Checked)
                phus.P_Hus_EventIkkeFyldt += externThread_BeskedModtager;       // tilmeld observer
            else
                phus.P_Hus_EventIkkeFyldt -= externThread_BeskedModtager;       // afmeld observer
        }

    }
}
